<template>
  <v-container>
    <h1>Tarifs de l'escrime</h1>
    <v-data-table
      :items="tarifs"
      :headers="headers"
      item-key="name"
      :items-per-page="-1"
      :mobile-breakpoint="0"
      show-expand
      single-expand
      hide-default-footer
      :expanded.sync="expanded"
      @click:row="toggleExpand"
      disable-sort
    >
      <template v-slot:item.data-table-expand="{ item, on, isExpanded }">
        <v-icon v-if="item.details" v-on="on">
          <template v-if="isExpanded">
            {{ mdiChevronUp }}
          </template>
          <template v-else>
            {{ mdiChevronDown }}
          </template>
        </v-icon>
      </template>

      <template v-slot:item.value="{ item, value }">
        <template v-if="item.details">
          {{ price(item.details[0].value) }}
          à
          {{ price(item.details[item.details.length - 1].value) }}
        </template>
        <template v-else>
          {{ value ? price(value) : 'Gratuit' }}
        </template>
      </template>

      <template v-slot:expanded-item="{ item, headers }">
        <td :colspan="headers.length" class="pa-0">
          <v-list class="ml-auto">
            <v-list-item v-for="detail in item.details" :key="detail.label">
              <v-list-item-content>
                <v-list-item-title>
                  {{ detail.label }} :
                  {{
                    detail.value.toLocaleString('fr-FR', {
                      style: 'currency',
                      currency: 'EUR',
                    })
                  }}
                </v-list-item-title>
              </v-list-item-content>
            </v-list-item>
          </v-list>
        </td>
      </template>
    </v-data-table>
  </v-container>
</template>

<script>
import { mapGetters } from 'vuex'
import { mdiChevronDown, mdiChevronUp } from '@mdi/js'

export default {
  data: () => ({
    mdiChevronDown,
    mdiChevronUp,

    headers: [
      {
        value: 'name',
        text: 'Élément',
      },
      {
        value: 'value',
        text: 'Prix',
      },
    ],
    trainingCosts: [
      {
        label: '1h',
        value: 158,
      },
      {
        label: '1h30',
        value: 198,
      },
    ],
    insuranceCosts: [
      {
        label: 'Licence Base',
        value: 0.22,
      },
      {
        label: 'Licence +',
        value: 1.8,
      },
    ],

    expanded: [],
  }),

  computed: {
    ...mapGetters(['currentSeason']),

    categories() {
      return this.$store.state.activities.escrime.categories
        .slice()
        .sort((a, b) => a.ageLowerLimit - b.ageLowerLimit)
    },

    licenceCosts() {
      const costs = []
      for (const category of this.categories) {
        const yearLowerLimit = category.ageUpperLimit
          ? this.currentSeason - category.ageUpperLimit
          : 'la nuit des temps'
        const yearUpperLimit = category.ageLowerLimit
          ? this.currentSeason - category.ageLowerLimit
          : 'maintenant'
        costs.push({
          label: `${category.name} (de ${yearLowerLimit} à ${yearUpperLimit})`,
          value: category.licenceCost,
        })
      }
      return costs
    },

    tarifs() {
      return [
        {
          name: 'Adhésion',
          details: [
            {
              label: 'Si tous vos entraînements sont à Crest ou Livron',
              value: 10,
            },
            {
              label: 'Si vous avez un entraînement à Valence (adhésion Spahis)',
              value: 27,
            },
          ],
        },
        {
          name: 'Licence',
          details: this.licenceCosts,
        },
        {
          name: 'Passeport compétition (M15-Vétérans)',
          value: 6,
        },
        {
          name: '1er entraînement',
          details: this.trainingCosts,
        },
        {
          name: "2ème entraînement (avec l'aval du maître d'armes)",
          value: 0,
        },
        {
          name: "3ème entraînement (avec l'aval du maître d'armes)",
          value: 50,
        },
      ]
    },
  },

  methods: {
    price(val) {
      return val.toLocaleString('fr-FR', {
        style: 'currency',
        currency: 'EUR',
      })
    },

    toggleExpand(item) {
      if (this.expanded[0] === item) {
        this.expanded = []
      } else if (item.details) {
        this.expanded = [item]
      }
    },
  },
}
</script>
